<template>
  <!-- 修改前请注释以前的 -->
   <!-- 搜索 -->
    <div>
      <el-input style="width: 200px; height: 30px; margin-right: 10px;" suffix-icon="Search" placeholder="请输入商品名称"
        v-model="productName"></el-input>
      <el-form-item label="商品类型" style="width: 200px; margin-right: 10px;display: inline-block">
        <el-select v-model="editForm.type" @change="(event: any) => searchByType(event)" placeholder="请选择">
          <el-option v-for="item in typeList" :key="item.value" :label="item.label" :value="item.value1" />
        </el-select>
      </el-form-item>
      <el-form-item label="商品状态" style="width: 200px;margin-right: 10px;display: inline-block">
        <el-select v-model="state" placeholder="请选择" @change="(event: any) => searchByState(event)">
          <el-option label="已上架" value="1" />
          <el-option label="已下架" value="0" />
        </el-select>
      </el-form-item>
      <el-button class="ml-5" type="primary" @click="onSearch(productName)" style="height: 25px;">搜索</el-button>
      <el-button type="warning" @click="reset" style="height:25px">重置</el-button>
    </div>
    <div style="margin: 15px 0">
      <el-popconfirm class="ml-5" confirm-button-text='确定' cancel-button-text='取消' icon="InfoFilled" icon-color="red"
        title="您确定批量删除这些数据吗？" @confirm="delBatch" width=180>
        <template #reference>
          <el-button style="height: 25px" class="ml-5" type="danger">批量删除 <el-icon style="margin-left: 5px;">
              <Remove />
            </el-icon></el-button>
        </template>
      </el-popconfirm>
    </div>
    <!-- 数据展示 -->
    <el-table :data="tableData" border stripe header-cell-class-name="headerBg"
      :cell-style="{ 'text-align': 'center', 'font-size': '16px' }" @selection-change="handleSelectionChange"
      :header-cell-style="{ 'text-align': 'center' }">
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="id" label="商品编号" width="80">
        <template #default="{ $index }">
          {{ $index + 1 }}
        </template>
      </el-table-column>
      <el-table-column prop="goodImg" label="商品图片">
        <template #default="scope">
          <div>
            <img :src="scope.row.goodImg" alt="" style="height: 50px;">
          </div>
        </template>
      </el-table-column>
      <el-table-column prop="name" label="商品名称"></el-table-column>
      <el-table-column prop="price" label="商品价格" width="180"></el-table-column>
      <el-table-column prop="type" label="商品类型"></el-table-column>
      <el-table-column prop="inventory" label="商品数量"></el-table-column>
      <el-table-column prop="createTime" label="创建时间"></el-table-column>
      <el-table-column prop="updateTime" label="更新时间"></el-table-column>
      <el-table-column label="商品状态">
        <template #default="scope">
          <div>
            <span style="margin-left: 10px" v-if="scope.row.isShelves == 1">上架</span>
            <span style="margin-left: 10px" v-if="scope.row.isShelves == 0">下架</span>
          </div>
        </template>
      </el-table-column>
      <el-table-column label="操作" width="250px">
        <template #default="scope">
          <el-button size="small" @click="ReviseOrView(scope.$index, scope.row , 0)">
            详情
          </el-button>
          <el-button size="small" @click="ReviseOrView(scope.$index, scope.row, 1)">
            编辑
          </el-button>
          <el-button size="small" @click="handleOff(scope.$index, scope.row)">
            <div v-if="scope.row.isShelves == 1">下架 </div>
            <div v-if="scope.row.isShelves == 0">上架 </div>
          </el-button>
          <el-popconfirm class="ml-5" confirm-button-text='确定' cancel-button-text='取消' icon="InfoFilled" icon-color="red"
          title="是否确认删除" @confirm="deleteProduct(scope.row.id)" width=180>
          <template #reference>
            <el-button  class="ml-5" type="danger">删除</el-button>
          </template>
        </el-popconfirm>
          <el-popconfirm confirm-button-text='确定' cancel-button-text='取消' icon="el-icon-info" icon-color="red"
            title="您确定删除吗？">
          </el-popconfirm>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页器 -->
    <div style="padding: 10px 0">
      <el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange"
        :current-page="searchParams.current" :page-size="searchParams.pageSize" :page-sizes="[5, 10, 15, 20]"
        :small="null" :disabled="null" :background="null" layout="total, sizes, prev, pager, next, jumper"
        :total="total" />
    </div>
  <!-- 编辑/详情表单 -->
  <el-dialog v-model="DialogVisible" :title="title">
    <el-form label-width="100px" :disabled="disabled">
      <el-form-item label="商品编号">
        <el-input v-model="editForm.id" disabled></el-input>
      </el-form-item>
      <el-form-item label="商品图片">
        <div v-if="editForm.goodImg">
          <img :src="editForm.goodImg" alt="商品图标" class="thumbnail" style="width: 100px; height: 100px;" />
        </div>
        <el-upload 
          ref="uploadProductImg"
          action="#" 
          list-type="picture-card" 
          :auto-upload="false" 
          multiple="true"
          :on-remove="handleRemove"
          @change="(event: any) => handleChange(event, 0)" 
          :on-exceed="Exceed_ProductImg"
          limit="1" >
          <el-icon>
            <Plus/>
          </el-icon>
        </el-upload>
      </el-form-item>
      <el-form-item label="商品名称">
        <el-input v-model="editForm.name"></el-input>
      </el-form-item>
      <el-form-item label="商品价格">
        <el-input v-model="editForm.price"></el-input>
      </el-form-item>
      <el-form-item label="产品类别" prop="type">
        <el-select v-model="editForm.type" @change="(event: any) => loadForm(event, 1)">
          <el-option v-for="item in typeList" :key="item.value" :label="item.label" :value="item.value1" />
        </el-select>
      </el-form-item>
      <el-form-item label="商品数量">
        <el-input v-model="editForm.inventory"></el-input>
      </el-form-item>
      <el-form-item label="商品状态">
        <el-select v-model="editForm.isShelves">
          <el-option label="上架" value="上架" />
          <el-option label="下架" value="下架" />
        </el-select>
      </el-form-item>
      <el-form-item label="是否为限定类产品" prop="festivalOrder">
        <el-select v-model="editForm.festivalOrder" @change="(event: any) => loadForm(event, 0)">
          <el-option label="是" value="1" />
          <el-option label="否" value="0" />
        </el-select>
      </el-form-item>
      <el-form-item label="商品标签">
        <el-input v-model="editForm.label"></el-input>
      </el-form-item>
      <el-form-item label="商品图文">
        <div v-if="editForm.detailImg">
          <img :src="editForm.detailImg" alt="商品图标" class="thumbnail" style="width: 100px; height: 100px;" />
        </div>
        <el-upload 
          ref="uploadProductDetail"
          action="#" 
          list-type="picture-card" 
          :auto-upload="false" 
          multiple="true"
          :on-remove="handleRemove"
          @change="(event: any) => handleChange(event, 1)" 
          :on-exceed="Exceed_ProductDetail"
          limit="1" >
          <el-icon>
            <Plus/>
          </el-icon>
        </el-upload>
      </el-form-item>
      <el-form-item label="商品描述">
        <el-input type="textarea" v-model="editForm.introDetail"></el-input>
      </el-form-item>
    </el-form>
    <template #footer >
      <span class="dialog-footer">
        <el-button @click="DialogVisible = false" :disabled="disabled">取消</el-button>
        <el-button type="primary" @click="saveEdit" :disabled="disabled">确认</el-button>
      </span>
    </template>
  </el-dialog>
</template>

<script setup lang="ts">
import { ElMessage , type UploadProps , genFileId ,type UploadRawFile  } from 'element-plus';
import { ref, onMounted, inject } from 'vue';
import myAxios from "@/api/myAxios";
const total = ref(0); //总页数
const idList = ref([]);
const searchParams: any = ref({ //封装分页
  current: 1, //当前页码
  pageSize: 5, //每页显示条数
  sortField: "id",  //根据ID分类
  sortOrder: "descend" //降序
})
const fileSimple = ref()
const disabled = ref(true)
const title = ref('')  //表单名字
const productName = ref('');
const DialogVisible = ref(false);
const state = ref('');  //根据商品上架状态select栏
const tableData : any= ref([]);
const editForm : any = ref({});
const reload : any = inject("reload")  //页面重新刷新 
const uploadProductImg : any = ref()  //图片上传的ref绑定
const uploadProductDetail : any = ref()  //图片上传的ref绑定
const typeList: any = ref([
  {
    value1: '',
    label: ''
  }
])
onMounted(() => { //页面加载时获取商品列表和分类页表
  getProductList()
  getTypeList()
})
const getProductList = async () => {
  try {
    const res = await myAxios.post('/goods/list/page', { ...searchParams.value });
    // console.log(res.data)
    if (res.data.code === 1) {
      tableData.value = res.data.data.records;
      total.value = parseInt(res.data.data.total)  //总数据量，用于分页
    } else {
      ElMessage({
        message: '获取数据失败',
      });
      return;
    }
  } catch (error) {
    ElMessage({
      message: '发生错误',
    });
  }
}
const getTypeList = async () => {
  const res = await myAxios.post('/category/list', {})  //获取商品列表
  for (let key in res.data.data) {    //循环赋值
    typeList.value[key] = {
      value1: res.data.data[key].typeName,
      label: res.data.data[key].typeName
    }
  }
}
const saveEdit = async () => { //编辑商品
  const res = await myAxios.post('/goods/update',{...editForm.value})
  if( res.data.code === 1 ) {
    ElMessage({
      type: 'success',
      message: '更新成功'
    })
    DialogVisible.value = false
  } else {
    ElMessage.error('更新失败，请检查字段')
  }
}
const searchByType =(event : any)=>{ //通过类别搜索
  searchParams.value.type = event
  searchParams.value.current = 1
  getProductList()
}
const searchByState = (event : any) => {  //通过商品是否上架/下架搜索
  searchParams.value.isShelves = event
  searchParams.value.current = 1
  getProductList()
}
//删除商品
const deleteProduct = async (index: number) => {
  console.log(typeof index)
  const res = await myAxios.post('/goods/delete', { id: index })
  console.log(res)
  if (res.data.code === 1) {
    ElMessage({
      type: 'success',
      message: '删除成功',
    })
    getProductList()
  }
  getTypeList()
}
//选中发生的方法--->将其赋值给批量删除的数组
//详情或编辑 
const ReviseOrView = (index: number, row: any , flag : number) => {
  //flag值不同显示不同内容  disabled开启和关闭
  flag ?  (title.value = "编辑商品" , disabled.value = false) : (title.value = "商品详情" , disabled.value = true)
  DialogVisible.value = true;
  editForm.value = row;
};
//下架商品(待优化，有问题，逻辑有问题)
const handleOff = async (index: number, row: any) => { 
  row.isShelves ? row.isShelves = 0 : row.isShelves = 1  //三元运算符  改变那一行的上架值
  editForm.value = row;
  const res = await myAxios.post('/goods/update',{...editForm.value}) 
  if(res.data.code === 1) {
    ElMessage({
      type:'success',
      message:'更新成功'
    })
  } 
}
//处理行数大小变化
const handleSizeChange = (newSize: any) => {
  searchParams.value.pageSize = newSize //新的页面数
  getProductList()
}
//处理当前表格变化
const handleCurrentChange = (Current: any) => {
  searchParams.value.current = Current
  getProductList()
}
//重置按钮
const reset = () => {
  reload()
};
//上传图片移除 --逻辑上移除
const handleRemove: UploadProps['onRemove'] = (uploadFile, uploadFiles) => {
  console.log(uploadFile, uploadFiles)
}
const Exceed_ProductImg: UploadProps['onExceed'] = (files , flag) => { //覆盖商品照片
  uploadProductImg.value!.clearFiles()
  const file = files[0] as UploadRawFile
  file.uid = genFileId()
  uploadProductImg.value!.handleStart(file)
}
const Exceed_ProductDetail: UploadProps['onExceed'] = (files) => {  //覆盖商品详情图片
  uploadProductDetail.value!.clearFiles()
  const file = files[0] as UploadRawFile
  file.uid = genFileId()
  uploadProductDetail.value!.handleStart(file)
}
//将 商品类别 赋值到表格里
const loadForm = (value: any, flag: number) => {
  flag ? editForm.value.type = value : editForm.value.festivalOrder = value  //三元运算符 flag=1 是关于"商品类别"选项的值  flag=0 是关于“是否为节日限定”选项的值
}
//图片上传请求  此请求只要选择了图片，就会默认上传
const handleChange = async (file: any, flag: number) => {
  fileSimple.value = file
  let formData = new FormData()  //这一步很重要 创建一个FormData对象
  formData.append("file", fileSimple.value.raw)  //fileSimple.value.raw 才是文件主体  将其以文件的格式插入formData
  const res = await myAxios({   //编写请求，与以前的请求不同，这一次要指定好头部类型和文件类型
    url: '/file/upload/server/not_login',
    method: 'post',
    headers: {
      'content-Type': 'multipart/form-data'
    },
    data: {
      biz: "test",
      file: formData.get("file") // 取出formData对象中的file
    }
  })
  if (res.data.code === 1) {
    //三元运算   当flag为0时，赋值给商品图片  flag为1时，赋值给详情图片
    flag ? editForm.value.detailImg = res.data.data : editForm.value.goodImg = res.data.data
  }
}
const onSearch = (data : String)=>{ //搜索按钮方法
  searchParams.value.name = data
  searchParams.value.current = 1
  getProductList()
}
 //批量删除
const delBatch = async ()=>{
  console.log(idList.value);
  const res = await myAxios.post('/goods/delBatch',{
    idList: idList.value
  })
  console.log(res.data);
  if(res.data.code === 1) {
    ElMessage({
      type: 'success',
      message: '批量删除成功'
    })
    getProductList()
  } else {
    ElMessage.error('删除失败')
  }
}
const load =()=>{}
</script>

<style scoped>
.headerBg {
  background-color: #eee !important;
}
</style>